
var host = "/";

/*
 * 保存服务范围数据
 */
function saveData(){

    if(config.polyline_array){
        var city = getQueryString("city");
        for (var i = 0; i < config.polyline_name_array.length; i++) {
            var name = config.polyline_name_array[i];
            for (var j = i + 1; j < config.polyline_name_array.length; j++) {
                if (name == config.polyline_name_array[j]) {
                    alert("条目名称重复，请重新编辑！");
                    return;
                }
            }
        }

        var resultData=[];

        for(var len = 0; len < config.polyline_array.length; len++){
            var area = {
                "service_area":[]
            };
            var pl = config.polyline_array[len];
            if(pl != null){
                var points_json = [];
                var points = pl.getPath();
                for(var p_num = 0; p_num < points.length; p_num ++){
                    var point = {
                        "lng":points[p_num].lng,
                        "lat":points[p_num].lat
                    }
                    points_json[p_num] = point;
                }
                var item_json = {
                     "name": config.polyline_name_array[len],
                     "points":points_json
                }
                area.service_area.push(item_json);

                resultData.push({"city":city,"id":config.polyline_id_array[len],"ranges":area})
            }
        }
        localStorage.setItem("area",JSON.stringify(resultData));
        
        console.log(city);
        console.log(resultData);
        
        alert(resultData);

//        window.opener.setMapData(resultData,city);
//        window.open("about:blank","_self").close();
        
    }
}

/**
 * 在地图上显示服务范围
 */
function showDataInMap(){
    //TODO 从服务器获取服务范围数据
    var city = getQueryString("city");  //地址栏参数domain/param?city=25
//    var data=window.opener.getMapData(city);
 var data=[{"city":"\u4e0a\u6d77","id":7691,"ranges":{"service_area":[{"name":"\u670d\u52a1\u8303\u56f41","points":[{"lng":121.569742,"lat":31.338211},{"lng":121.562843,"lat":31.345489},{"lng":121.585264,"lat":31.351287},{"lng":121.603805,"lat":31.357208},{"lng":121.639594,"lat":31.342776},{"lng":121.673262,"lat":31.318223},{"lng":121.690222,"lat":31.306623},{"lng":121.697696,"lat":31.298477},{"lng":121.731616,"lat":31.244402},{"lng":121.739342,"lat":31.219823},{"lng":121.742504,"lat":31.214264},{"lng":121.742504,"lat":31.211299},{"lng":121.74351,"lat":31.20957},{"lng":121.738767,"lat":31.188689},{"lng":121.726981,"lat":31.167309},{"lng":121.712464,"lat":31.154825},{"lng":121.692199,"lat":31.143947},{"lng":121.660722,"lat":31.135416},{"lng":121.640025,"lat":31.138136},{"lng":121.624071,"lat":31.136776},{"lng":121.607686,"lat":31.142463},{"lng":121.598056,"lat":31.151735},{"lng":121.598631,"lat":31.151735},{"lng":121.598775,"lat":31.152353},{"lng":121.5982,"lat":31.152106},{"lng":121.598344,"lat":31.152477},{"lng":121.5982,"lat":31.151117},{"lng":121.598487,"lat":31.152106},{"lng":121.598056,"lat":31.151858},{"lng":121.596475,"lat":31.155443},{"lng":121.598775,"lat":31.151364},{"lng":121.596619,"lat":31.155072},{"lng":121.5982,"lat":31.151117},{"lng":121.576928,"lat":31.163725},{"lng":121.574485,"lat":31.164219},{"lng":121.575635,"lat":31.163354},{"lng":121.575203,"lat":31.164467},{"lng":121.517748,"lat":31.217229},{"lng":121.520047,"lat":31.222665},{"lng":121.511711,"lat":31.236251},{"lng":121.504237,"lat":31.243414},{"lng":121.5028,"lat":31.245637},{"lng":121.511136,"lat":31.248848},{"lng":121.51861,"lat":31.250577},{"lng":121.538732,"lat":31.252059},{"lng":121.555117,"lat":31.259714},{"lng":121.572939,"lat":31.274283},{"lng":121.580701,"lat":31.287122},{"lng":121.574664,"lat":31.301686},{"lng":121.571502,"lat":31.309585},{"lng":121.57179,"lat":31.310078},{"lng":121.57179,"lat":31.310078},{"lng":121.57179,"lat":31.310078}]}]}},{"city":"\u4e0a\u6d77","id":7692,"ranges":{"service_area":[{"name":"\u670d\u52a1\u8303\u56f42","points":[{"lng":121.217031,"lat":31.282801},{"lng":121.219115,"lat":31.283974},{"lng":121.223032,"lat":31.284005},{"lng":121.232266,"lat":31.286751},{"lng":121.259287,"lat":31.300576},{"lng":121.277828,"lat":31.321185},{"lng":121.287027,"lat":31.320568},{"lng":121.295794,"lat":31.323406},{"lng":121.312611,"lat":31.330192},{"lng":121.328277,"lat":31.33562},{"lng":121.344375,"lat":31.338828},{"lng":121.361191,"lat":31.336237},{"lng":121.386056,"lat":31.343639},{"lng":121.39123,"lat":31.346846},{"lng":121.399567,"lat":31.342159},{"lng":121.41049,"lat":31.340678},{"lng":121.428025,"lat":31.337717},{"lng":121.426731,"lat":31.338334},{"lng":121.426731,"lat":31.338581},{"lng":121.437799,"lat":31.337841},{"lng":121.445416,"lat":31.336977},{"lng":121.478618,"lat":31.311436},{"lng":121.48796,"lat":31.308104},{"lng":121.49529,"lat":31.299958},{"lng":121.495865,"lat":31.291812},{"lng":121.499027,"lat":31.283912},{"lng":121.49644,"lat":31.283665},{"lng":121.491122,"lat":31.276258},{"lng":121.492128,"lat":31.272554},{"lng":121.497015,"lat":31.279098},{"lng":121.514837,"lat":31.298971},{"lng":121.51455,"lat":31.300081},{"lng":121.515125,"lat":31.299711},{"lng":121.514837,"lat":31.299218},{"lng":121.513544,"lat":31.300822},{"lng":121.513256,"lat":31.300081},{"lng":121.514119,"lat":31.299711},{"lng":121.515556,"lat":31.299218},{"lng":121.514837,"lat":31.299094},{"lng":121.490116,"lat":31.277122},{"lng":121.514837,"lat":31.297983},{"lng":121.514837,"lat":31.2986},{"lng":121.494284,"lat":31.2749},{"lng":121.489685,"lat":31.275517},{"lng":121.497159,"lat":31.282307},{"lng":121.499602,"lat":31.282677},{"lng":121.502333,"lat":31.281443},{"lng":121.501039,"lat":31.283788},{"lng":121.488535,"lat":31.263789},{"lng":121.486594,"lat":31.259467},{"lng":121.470281,"lat":31.256504},{"lng":121.4687,"lat":31.250083},{"lng":121.472581,"lat":31.242426},{"lng":121.473156,"lat":31.234399},{"lng":121.474162,"lat":31.231311},{"lng":121.475599,"lat":31.230446},{"lng":121.466257,"lat":31.224394},{"lng":121.456196,"lat":31.219453},{"lng":121.449728,"lat":31.206482},{"lng":121.442541,"lat":31.188813},{"lng":121.427737,"lat":31.166939},{"lng":121.41667,"lat":31.149386},{"lng":121.391661,"lat":31.132449},{"lng":121.377863,"lat":31.129234},{"lng":121.363059,"lat":31.125401},{"lng":121.357885,"lat":31.123917},{"lng":121.325834,"lat":31.14642},{"lng":121.304705,"lat":31.147532},{"lng":121.289901,"lat":31.157298},{"lng":121.26748,"lat":31.173366},{"lng":121.227954,"lat":31.196598},{"lng":121.224217,"lat":31.231187},{"lng":121.222924,"lat":31.236745},{"lng":121.220768,"lat":31.25354},{"lng":121.216168,"lat":31.262431},{"lng":121.211857,"lat":31.269468},{"lng":121.210994,"lat":31.272308},{"lng":121.210419,"lat":31.273543},{"lng":121.210419,"lat":31.273543},{"lng":121.210419,"lat":31.273543}]}]}}];

if(!city){
    city="上海";
}
console.log(data);
    confirmCity(city);
    config.polyline_array = [];
    config.polyline_name_array=[];
    config.polyline_id_array=[];
    if(data){
        data.forEach(function (item,index,array) {
            drawMap(item.ranges,item.id);
        });
    }
}

function confirmCity(city){
    var option = {
        onSearchComplete: function(results){
            if (local.getStatus() == BMAP_STATUS_SUCCESS){
                if(results.getCurrentNumPois()){
                    // map.centerAndZoom(results.getPoi(0).point,15);
                    //map.setCenter(value);
                    if(results.getCurrentNumPois()){
                        map.setCenter(results.getPoi(0).point,15);
                    }
                    resetMapCenter();
                    //exitSetCity(city);
                }
            }else{
                alert("没有检索到您输入的城市");  // url 必须带city参数
                exitSetCity();
            }
        }
    };
    var local = new BMap.LocalSearch(map,option);
    local.search(city);
}

function drawMap(areaStr,id){
    //var areaStr = localStorage.getItem("area");
    var areaObj;
    if( typeof(areaStr)==='object'){
        areaObj=areaStr;
    }else{
        areaObj = JSON.parse(areaStr);
    }
    if(areaObj){
        //清空服务范围缓存
        //对服务范围数据进行遍历
        for(var len = 0;len< areaObj.service_area.length;len++){
            var area_item = areaObj.service_area[len];
            if(area_item){
                var polyPoint = [];
                var name = area_item.name;
                var points = area_item.points;
                for(var p_num = 0; p_num < points.length; p_num ++){
                    var point = new BMap.Point(points[p_num].lng,points[p_num].lat);
                    polyPoint.push(point);
                    if(p_num ==0){
                        map.centerAndZoom(point, 12);
                    }
                }
                //在地图上绘制服务范围区域
                var polygon = new BMap.Polygon(polyPoint, {
                    strokeColor:polyDefaultStyle.strokeColor,
                    strokeWeight:polyDefaultStyle.strokeWeight,
                    strokeOpacity:polyDefaultStyle.strokeOpacity});
                map.addOverlay(polygon);

                //将服务范围加入到缓存中
                config.polyline_array.push(polygon);
                config.polyline_name_array.push(name);
                config.polyline_id_array.push(id);
                //添加对应的左侧列表条目
                var dom = '<div class = "bg_item l"><input class = "marker_title l" maxlength="15" style="display: inline-block;width:150px">'
                    +  '<span class = "editing r show" onclick = "deletePolyline(' + config.polyline_array.length + ')">删除</span>'
                    +  '<span class = "editing show" onclick = "editPolyline('+(config.polyline_array.length - 1)+')">编辑  | </span></div>';
                var item=$(dom);
                var position=config.polyline_name_array.length-1;
                item.find('.marker_title').val(name);
                item.find('.marker_title').off('input').on('input', function(){
                    if (item.find('.marker_title').val().length > 15) {
                        alert('最多输入15个字');
                    }
                });
                item.find('.marker_title').off('blur').on('blur',function () {
                    config.polyline_name_array[position]=item.find('.marker_title').val();
                });
                $("#list_polyline").append(item);

            }
        }
    }
}

function getQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
    var r = decodeURIComponent(window.location.search).substr(1).match(reg);
    if (r != null) {
        var v = unescape(r[2]);
        return v;
    }
    return "";
}